package scaffali;

public class Ripiano
{
	/**
	* Larghezza del ripiano misurata in mm.
	*/
	int larghezza;
	Pubblicazione[] pubs;

	int spazioOccupato;
	int numPub;

	public Ripiano(int l)
	{
		larghezza = l;
		pubs = new Pubblicazione[larghezza/Pubblicazione.minSpes];
		spazioOccupato = 0;
		numPub = 0;
	}

	public int inserisci(Pubblicazione p)
	{
		if( (larghezza - spazioOccupato) < p.getSpessore())//non ci sta piu'
		{
			return -1;
		}

		spazioOccupato = spazioOccupato + p.getSpessore();
		pubs[numPub] = p;

		/*
		//post incremento, prima lo uso e poi lo incremento: torno numPub ma alla fine ottengo che numPub sia incrementato
		return numPub++;
		*/

		/*
		numPub = numPub + 1;
		return numPub-1;
		*/

		int retval = numPub;
		numPub++;
		return retval;//ritorno la posizione di inserimento della pubblicazione
	}

	public int cerca(String titolo)
	{
		int i = 0;
		for(i=0;i<numPub;i++)
		{
			/* Protetto dalla short circuit rule
			if(pubs[i] != null && titolo.equals(pubs[i].getTitolo()))
			*/

			//con il loop limitato a numPub non servono ulteriori protezioni
			if(titolo.equals(pubs[i].getTitolo()))
			{
				return i;
			}
		}
		return -1;
	}

	public int rimuovi(String titolo)
	{
		int i = 0;
		int retval = -1;
		boolean trovato = false;
		for(i=0;i<numPub;i++)
		{
			if(!trovato)
			{
				if(titolo.equals(pubs[i].getTitolo()))
				{
					trovato = true;
					retval = i;
					spazioOccupato -= pubs[i].getSpessore();
				}
			}
			if(trovato && i < pubs.length-1)
			{
				pubs[i] = pubs[i+1];
			}
			if(trovato && i == pubs.length-1)
			{
				pubs[i] = null;
			}
		}
		numPub--;
		return retval;
	}

	public int getSpazioLibero()
	{
		return larghezza-spazioOccupato;
	}

	public int getSpazioOccupato()
	{
		return spazioOccupato;
	}

	public int getNumeroPubblicazioni()
	{
		return numPub;
	}

	public void serializzati(java.io.PrintWriter pw)
	{
		for(int i = 0;i<getNumeroPubblicazioni();i++)
		{
			pubs[i].serializzati(pw);
		}
	}

	public String toString()
	{
		String retval = "Ripiano largo " + larghezza + " mm, contenente " + getNumeroPubblicazioni() + " pubblicazioni, con ancora " + getSpazioLibero() + " mm liberi\n";
		for(int i = 0;i<getNumeroPubblicazioni();i++)
		{
			retval = retval.concat(pubs[i].toString() + ", ");
		}
		return retval;
	}
}
